# frozen_string_literal: true
require 'steam/proto/version'

module Steam
  # Access to the various Steam Protobuf definitions
  module Proto
    def self.load_protobufs(*args)
      args = args.flatten.dup.map(&:to_sym)

      args.each do |arg|
        raise "Failed to load protobufs for #{arg}" unless allowed?(arg)
        require "steam/proto/#{arg}"
      end
    end

    def self.allowed?(arg)
      allowed_requires.include?(arg)
    end

    def self.allowed_requires
      [:csgo, :steamclient, :gc]
    end
  end
end
